#! /usr/bin/perl

############################################################
#
# linmag.pl
#
# CGI-Script zur Artikelverwaltung
#
############################################################
#
# Dieses Script unterliegt der GNU General Public License
#
# Copyright (C) 1999 by ObLi, Marcus Obst <mobst@gmx.de>
#
############################################################
#
# $Revision: 0.6 $
# $Date: 1999/06/14 15:18:52 $
#
############################################################


###########################################################################
#
#  Librays
#
###########################################################################

use Mysql;			# bentigt das Mysql-Modul fr Perl
				# bei Debian im Paket "libdbd-mysql"
				# ansonsten unter auf dem CPAN

use CGI qw/:standard :html3/;   # bei jedem neuen Perl dabei

###########################################################################
#
# Variablen
#
###########################################################################

$head = "Linuxmagazin - Artikeldatenbank";
	# berschrift fr jede Html-Ausgabe
$db = "linuxmagazin";
	# Name der Artikeldatenbank
$table = "artikel";
	# Name der Tabelle die Artikel enthlt
$user = "linmag";
	# Nutzer fr Artikelverwaltung
$pass = "XXXX";
	# Passwort fr Artikelverwaltung
$copy = "<P><HR>Copyright &#169 1999 Dresden<BR>Marcus Obst <A HREF='mailto:mobst\@gmx.de'>mobst\@gmx.de</A>";
	# String mit Copyrightinformationen
$links = "<HR><A HREF=/cgi-bin/linmag.pl/html_find>Artikel Suchen</A><BR><HR><P>";
	# Diese Links werden in jedes Html-Dokument eingegfgt

###########################################################################
#
# Funktionen
#
###########################################################################


####################
# 
#  db_connect;
#  Verbindung zur Datenbank herstellen
#

sub db_connect {
	$dbh=Mysql->connect(undef,$db,$user,$pass);
 	die "$Mysql::db_errstr\n" if ($Mysql::db_errstr);
}

####################
#
#  db_find;
#  Sucht Artikel in Datenbank
#

sub db_find {
	&db_connect;
	import_names('R');
	$sth=$dbh->query("select id,titel,heft,seite,autor from $table where concat(titel,beschreibung,autor) LIKE ".$dbh->quote("%$R::key1%"). "order by titel");
	die "$Mysql::db_errstr\n" if ($Mysql::db_errstr);
	my $howmany=$sth->numrows;
	die "$Mysql::db_errstr\n" if ($Mysql::db_errstr);
	print header,
	      start_html('-title' => "$head: Suchergebnis bersicht",
			 '-BGCOLOR' => '#ffffff'),
	      h1("$head: Suchergebnis bersicht"),
	      $links,
	      h3("Es wurde(n) $howmany Artikel gefunden."),p;
	print "<TABLE BORDER>";
	print "<TR><TH>Titel:<TH>Heft:<TH>Seite:<TH>Autor(en)";
	while(@temp=$sth->fetchrow) {
		die "$Mysql::db_errstr\n" if ($Mysql::db_errstr);
		print "<TR><TD><A HREF=/cgi-bin/linmag.pl/db_show/$temp[0]>$temp[1]</A><TD>$temp[2]<TD>$temp[3]<TD>$temp[4]";
	}
	print "</TABLE>",
	      $copy,
              end_html;
}

####################
#
#  db_show;
#  Zeigt Informationen zu Artikel an
#

sub db_show {
	&db_connect;
	my $sth=$dbh->query("select * from $table where id = $_[0]");
	die "$Mysql::db_errstr\n" if ($Mysql::db_errstr);
	print header,
	      start_html('-title' => "$head: Suchergebnis genaue Information",
			 '-BGCOLOR' => '#ffffff'),
	      h1("$head: Suchergebnis genaue Information"),
	      $links;
	while(@temp=$sth->fetchrow) {
	        print table( {'-border' => 1},
	              TR({'-align' => 'left'},th('ID:'),td($temp[0])),
		      TR({'-align' => 'left'},th('Titel:'),td($temp[1])),
		      TR({'-align' => 'left','-valign' => 'top'},th('Beschreibung:'),td($temp[2])),
		      TR({'-align' => 'left'},th('Heft:'),td($temp[3])),
		      TR({'-align' => 'left'},th('Seite:'),td($temp[4])),
		      TR({'-align' => 'left'},th('Autor(en):'),td($temp[5])));
	}
	print $copy,
	      end_html;
}

####################
#
#  html_find;
#  Eingabemaske zum Suchen
#

sub html_find  {
	      print header,
              start_html('-title' => "$head: Artikel suchen",
			 '-BGCOLOR' => '#ffffff'),
	      h1("$head: Artikel suchen"),
	      $links,
              start_form('-method' => 'POST',
			 '-action' => '/cgi-bin/linmag.pl/db_find'),
	      table(
	       TR(th("Suche:"),td(textfield('-name' => 'key1','-size' => '40')),
	       )),
	       # td(popup_menu('-name' => 'action','-values' => ['OR','AND']))),
	       # TR(td(),td(textfield('-name' => 'key2','-size' => '40')))),
	      p,
	      submit('-value' => 'Suchen'),
	      reset('-value' => 'lschen'),
	      end_form,
	      $copy,
	      end_html;
}
	      
###########################################################################
#
# Hauptprogramm
#
###########################################################################

eval {
   if ($ENV{'PATH_INFO'} =~ m#^/db_find#)	      { &db_find;    }
   elsif ($ENV{'PATH_INFO'} =~ m#^/db_show/([0-9]*)#) { &db_show($1);}
   else                                               { &html_find; }
};

if ($@) {
	my $fehler=$@;
	print header,
	      start_html('-title' => 'ACHTUNG Fehler !!!',
			 '-BGCOLOR' => '#ffffff'),
	      h1("$head: FEHLER"),
	      $links,
	      "Beim Abarbeiten des Scriptes ist folgender Fehler aufgetreten: ",p,
	      h3("$fehler"),p,
	      "Wenn Ihnen etwas unklar ist bzw. Sie keine Lsung finden, schicken Sie einfach eine Mail mit kurzer Fehlerbeschreibung an <A HREF=mailto: mobst\@gmx.de>mobst\@gmx.de</A>",
	      $copy,
	      end_html;
}
